#!/bin/bash
set +o posix

# $ bash poem-rater-cleaned.sh 1000 2019-10-17-117mclean-samples.txt pg-clean

N="$1" # currently needs to be a multiple of 8
CORPUS="$2" # "/home/gwern/wiki/docs/ai/2019-03-06-gpt2-poetry-1000samples.txt"
JSON="$3"

encode() {
    TMP_FILE=$(mktemp /tmp/XXXX.txt)
    echo "$@" >> $TMP_FILE
    ENCODED=$(PYTHONPATH=src python3 encode2.py --model_name 2019-03-06-gwern-gpt2-poetry-projectgutenberg-network519407  $TMP_FILE)
    echo "$ENCODED"; rm "$TMP_FILE"; }
export -f encode

generateJson() {
    echo "{\"query\": [0,0], \"sample0\": $2, \"sample1\": $3, \"best\": $1}," >> $JSON-encoded.json;
    ## Store a backup copy of the plain text for easier consultation
    echo "{\"query\": [0,0], \"sample0\": $4, \"sample1\": $5, \"best\": $1}," >> $JSON-text.json;
}

rm -rf /tmp/poem-samples/; mkdir /tmp/poem-samples/
cat "$CORPUS" | grep -v -e '==.*' | csplit --quiet --prefix /tmp/poem-samples/sample- --suppress-matched - '/^$/' '{*}'
find /tmp/poem-samples/ -type f -size 0 -delete

generateEncoded() {
    POEM="$@"
    FIRST=$(head -25 $POEM)
    encode "$FIRST" >> $POEM.encoded
}
export -f generateEncoded
find /tmp/poem-samples/ -name "sample-*" -type f | shuf | head -$1 | parallel generateEncoded

I=0
echo "[" >> $JSON-encoded.json; echo "[" >> $JSON-text.json;
for POEM in `ls /tmp/poem-samples/sample-*.encoded | sed -e 's/\.encoded//' | sort|head -$1`; do
    FIRST=$(head -25 $POEM)
    FIRST_ENCODED=$(cat $POEM.encoded)
    POEM2=$(ls /tmp/poem-samples/sample-*.encoded | sed -e 's/\.encoded//' |shuf|head -1)
    SECOND=$(tail -25 $POEM2)
    SECOND_ENCODED=$(cat $POEM2.encoded)

    echo -e "\n\e[1m--------------------------------------------\e[0m"
    echo "$FIRST"
    echo "============================================="
    echo "$SECOND"
    echo "" # print a newline to make output easier to read and divide from the foregoing

    echo -e "[$I] 1: \e[1mFirst\e[0m wins | 2: \e[1mSecond\e[0m wins | x: e\e[1mX\e[0mit"
    read -N 1 RATING
    case "$RATING" in

        $'\n')
        # skip
        ;;

        1)
            generateJson 0 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        2)
            generateJson 1 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        x)
            break
            ;;
    esac
    I=$((I+1))
done
echo "]" >> $JSON-text.json; echo "]" >> $JSON-encoded.json
