#!/bin/bash

N=$1
PROMPT_CORPUS=$2 # eg gutenberg-poetry-v001.txt
JSON=$3

mkdir /tmp/poem-samples/ || rm -rf /tmp/poem-samples/ && mkdir /tmp/poem-samples/
for i in `seq 0 $N`; do
    PROMPT=$(cat $PROMPT_CORPUS | shuf | head -1)
    SAMPLE1=$(mktemp /tmp/poem-samples/sample-XXXXX.txt)
    # Hand-parallelize over my 2 GPUs:
    echo "$PROMPT" >> $SAMPLE1
    echo "$PROMPT" | CUDA_VISIBLE_DEVICES=0 python src/conditional_samples.py --top_p 0.99 --model_name 345M-poetry --nsamples 1 | sed -e 's/.*|//' | fgrep -v '=' >> $SAMPLE1 &
    SAMPLE2=$(echo $SAMPLE1.2)
    echo "$PROMPT" >> $SAMPLE2
    echo "$PROMPT" | CUDA_VISIBLE_DEVICES=1 python src/conditional_samples.py --top_p 0.99 --model_name 345M-poetry --nsamples 1 | sed -e 's/.*|//' | fgrep -v '=' >> $SAMPLE2
    wait
done


encode() {
    TMP_FILE=$(mktemp /tmp/XXXX.txt)
    echo "$@" >> $TMP_FILE
    ENCODED=$(PYTHONPATH=src python encode2.py --model_name 2019-03-06-gwern-gpt2-poetry-projectgutenberg-network519407  $TMP_FILE)
    echo "$ENCODED"; rm "$TMP_FILE"; }
export -f encode
generateJson() {
    echo "{\"query\": [0,0], \"sample0\": $2, \"sample1\": $3, \"best\": $1}," >> $JSON-encoded.json;
    ## Store a backup copy of the plain text for easier consultation
    echo "{\"query\": [0,0], \"sample0\": $4, \"sample1\": $5, \"best\": $1}," >> $JSON-text.json;
}
generateEncoded() {
    POEM="$@"
    FIRST=$(head -23 $POEM)
    encode "$FIRST" >> $POEM.encoded
    SECOND=$(head -23 $POEM.2)
    encode "$SECOND" >> $POEM.2.encoded
    SECOND_ENCODED=$(encode "$SECOND")
}
export -f generateEncoded
ls /tmp/poem-samples/sample-* | sort | head -$1 | parallel generateEncoded

I=0
echo "[" >> $JSON-encoded.json; echo "[" >> $JSON-text.json;
for POEM in `ls /tmp/poem-samples/*.txt|sort`; do
    FIRST=$(head -20 $POEM)
    FIRST_ENCODED=$(cat $POEM.encoded)
    SECOND=$(head -20 $POEM.2)
    SECOND_ENCODED=$(cat $POEM.2.encoded)

    echo -e "\n\e[1m--------------------------------------------\e[0m"
    echo "$FIRST"
    echo "============================================="
    echo "$SECOND"
    echo "" # print a newline to make output easier to read and divide from the foregoing

    echo -e "[$I] 1: \e[1mFirst\e[0m wins | 2: \e[1mSecond\e[0m wins | x: e\e[1mX\e[0mit"
    read -N 1 RATING
    case "$RATING" in

        $'\n')
        # skip
        ;;

        1)
            generateJson 0 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        2)
            generateJson 1 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        x)
            break
            ;;
    esac
    I=$((I+1))
done
echo "]" >> $JSON-text.json; echo "]" >> $JSON-encoded.json
