#!/bin/bash
set +o posix

# $ bash poem-rater.sh 1000 2019-05-13-gpt2-poetry-335m-5000samples.txt 1

N="$1" # currently needs to be a multiple of 8
CORPUS="$2" # "/home/gwern/wiki/docs/ai/2019-03-06-gpt2-poetry-1000samples.txt"
JSON="$3"

encode() {
    TMP_FILE=$(mktemp /tmp/XXXX.txt)
    echo "$@ <|endoftext|>" >> $TMP_FILE
    ENCODED=$(PYTHONPATH=src python3 encode2.py --model_name 2019-03-06-gwern-gpt2-poetry-projectgutenberg-network519407  $TMP_FILE)
    echo "$ENCODED"; rm "$TMP_FILE"; }
export -f encode
generateJson() {
    echo "{\"query\": [0,0], \"sample0\": $2, \"sample1\": $3, \"best\": $1}," >> $JSON-encoded.json;
    ## Store a backup copy of the plain text for easier consultation
    echo "{\"query\": [0,0], \"sample0\": $4, \"sample1\": $5, \"best\": $1}," >> $JSON-text.json;
}


rm -rf /tmp/poem-samples/; mkdir /tmp/poem-samples/
cat "$CORPUS" | fgrep -v '=' | sed -e ':a;N;$!ba;s/<|endoftext|>/\n/g' | split --lines=1 - /tmp/poem-samples/sample-
find /tmp/poem-samples/ -name "sample-*" -exec wc --chars {} \;
for FILE in `ls /tmp/poem-samples/sample-*`; do
    [[ $(cat $FILE | wc --chars) -lt 100 ]] && rm $FILE
done
find /tmp/poem-samples/ -name "sample-*" -exec fgrep -v -l '⏎' {}  \; | xargs -n 5000 rm
find /tmp/poem-samples/ -name "sample-*" | shuf | tail +$1 | xargs -n 5000 rm
sed -i -e 's/⏎/\n/g' /tmp/poem-samples/*

generateEncoded() {
    POEM="$@"
    FIRST=$(head -20 $POEM)
    encode "$FIRST" >> $POEM.encoded
    # SECOND=$(tail -20 $POEM)
    # encode "$SECOND" >> $POEM.2.encoded
    # SECOND_ENCODED=$(encode "$SECOND")
}
export -f generateEncoded
ls /tmp/poem-samples/sample-* | sort | head -$1 | parallel generateEncoded

I=0
echo "[" >> $JSON-encoded.json; echo "[" >> $JSON-text.json;
for POEM1 in `ls /tmp/poem-samples/sample-*|fgrep -v encoded|sort|head -$1`; do
    FIRST=$(head -20 $POEM1)
    FIRST_ENCODED=$(cat $POEM1.encoded)

    POEM2=$(ls /tmp/poem-samples/sample-* | fgrep -v encoded | fgrep -v $POEM1 | shuf | head -1)
    SECOND=$(head -20 $POEM2)
    SECOND_ENCODED=$(cat $POEM2.encoded)

    echo -e "\n\e[1m--------------------------------------------\e[0m"
    echo "$FIRST"
    echo "============================================="
    echo "$SECOND"
    echo "" # print a newline to make output easier to read and divide from the foregoing

    echo -e "[$I] 1: \e[1mFirst\e[0m wins | 2: \e[1mSecond\e[0m wins | x: e\e[1mX\e[0mit"
    read -N 1 RATING
    case "$RATING" in

        $'\n')
        # skip
        ;;

        1)
            generateJson 0 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        2)
            generateJson 1 "$FIRST_ENCODED" "$SECOND_ENCODED" "$FIRST" "$SECOND"
            ;;
        x)
            break
            ;;
    esac
    I=$((I+1))
done
echo "]" >> $JSON-text.json; echo "]" >> $JSON-encoded.json
